<?

/***************************************************************************************
 *											*
 *   	Copyright 2006 by Davide Simoncelli                                      	*
 *   	Email: netcelli_gentoo at users dot sourceforge dot net                      	*
 *                                                                         		*
 *   	This program is free software; you can redistribute it and/or			*
 *	modify it under the terms of the GNU General Public License			*
 *	as published by the Free Software Foundation; either version 2			*
 *	of the License, or (at your option) any later version.				*
 *											*
 *	This program is distributed in the hope that it will be useful,			*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of			*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *	GNU General Public License for more details.					*
 *											*
 *	You should have received a copy of the GNU General Public License		*
 *	along with this program; if not, write to the Free Software			*
 *	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.	*	
 *											*
 ****************************************************************************************/

/**
 *	@name YnHubProfile
 * 	@since VHCP 1.7
 * 	@package VHCP
*/

class PtokaxProfile
{

    private $Nick;
    private $Password;
    private $Profile;
    
     /**
	 * Construct function
	 * @param array $aa the array that contains the user's nickname, password and profile
	 * @access public
	 * @return void
	 */
    
    
    public function __construct($aa)
    {
        foreach ($aa as $k=>$v) $this->$k = $aa[$k];
    }
    
    /**
	 * Return the user's nickname
	 * @access public
	 * @return string the nick to add into the database
	 */
    
    public function getNick()
    {
    	return $this->Nick;
    }
    
    /**
	 * Return the user's password
	 * @access public
	 * @return string the password to add into the database
	 */
    
    public function getPassword()
    {
    	return $this->Password;
    }
    
    /**
	 * Return the nick's profile; it will be converted into the five Verli Class (10 Master, 5 Admin, 4 Cheef, 3 Operator, 2 VIP , 1 Reg). Ptokax is able to create new profiles so its the user that must choose the equivalent verli class for each profile
	 * @access public
	 * @return string the profile to add into the database
	 */
    
    public function getProfile()
    {
    	return $this->Profile;
    }
    
      /**
	 * Return the nick's profile; it will be converted into the five Verli Class (10 Master, 5 Admin, 4 Cheef, 3 Operator, 2 VIP , 1 Reg). Ptokax is able to create new profiles so its the user that must choose the equivalent verli class for each profile
	 * @access public
	 * @return string the profile to add into the database
	 */
    
    public function getCreatedBy()
    {
    	return $this->CreatedBy;
    }
}

/**
 *	@name AquilaProfile
 * 	@since VHCP 1.7
 * 	@static
 * 	@package VHCP
*/

class AquilaProfile
{
	/**
	 * Open the Aquila reg file; it stored each line (or user) in an array; that one should be splitted
	 * @access private
	 * @return array it's the array that contains some stuff, like nick, password, group, reg date, etc.
	 */
	
	private function openFile($file)
	{
		$fp = fopen ($file, "r");
		$i = 0;
		while ($line = fgets ($fp))
		{
			$regs[$i] = $line;
			$i++;
		}
		fclose ($fp);
		return $regs;
	}
	
	/**
	 * Build the query from the array given by openFile() method; the query will be run to add a new user into the database
	 * @access public
	 * @var string $file the file to explode and get Aquila profiles
	 * @return void
	 */
	
	public function buildQuery($file)
	{
		$class = array ( 0 => 10, 1 => 5, 2 => 4, 3 => 3, 4 => 2, 5 => 1 );
		$regs = AquilaProfile::openFile($file);
		$i = 0;
		$j = 0;
		$error = array();
		foreach ($regs as $profile)
		{
			$i++;
			$data = explode(" ", $profile);
			if (!mysql_query("INSERT INTO `reglist` (`nick`, `class`, `reg_date`, `reg_op`, `login_pwd`) VALUES ('".addslashes($data[1])."', '{$class[$data[4]]}', '{$data[5]}', '{$data[6]}', '{$data[2]}')"))
			{
				$error[$j] = $data[1];
				$j++;
			}
		}
		echo "<tr>
				<td colspan=\"2\">
					$i users have been imported into the database";
				if (count($error) > 0 )
				{	
					echo "; the following users already exist:<br>";
					foreach ($error as $key => $user) echo "- $user<br>";
				}
		echo "	</td>
			</tr>";
		unlink($_SESSION['file_name']);
		unset($_SESSION['file_name']);
	}
}

/**
 *	@name ConversionUtility
 * 	@since VHCP 1.7
 * 	@static
 * 	@package VHCP
*/

class ConversionUtility
{
	/**
	 * Print the main menu for conversion.php page; it should be used for Aquila, Ptokax and YnHub reg conversion
	 * @access public
	 * @return void
	 */
		
	public function printPtoMenu($step,$tag)
	{
		global $classes;
		//$ptoRegFile= "/home/netcelli/Desktop/RegisteredUsers.xml";
		$ptoRegFile = $_SESSION['file_name'];
		$db = ConversionUtility::readPtoFile($ptoRegFile,$tag);
		switch ($step)
		{
			case 3:
				$profiles = ConversionUtility::detectProfile($db);
				if ($tag == 'Account') echo "<form action=\"./?page=conversion&conversion_type=ynhub&step=4\" method=\"post\">";
				else echo "
				<form action=\"./?page=conversion&conversion_type=ptokax&step=4\" method=\"post\">";
				
				echo "<tr>
						<td colspan=\"2\">
						<br> ".count($profiles)." profiles have been detected; you should specify for each of them the correspond class of Verlihub
						</td>
					</tr>";
				foreach ($profiles as $key => $number)
				{
					echo "<tr>
	    						<th width =\"100px\">Profile n. $number</th>
							<td>";
					echo Utility::ClassSelectMenuImpo(1,"profile_$number");
					echo "</td>";
				}
				echo "<tr>
	    					<td>&nbsp;</td>
							<td><input type=\"submit\" value=\"Go\" class=\"submit\"  /></td>
	  					</tr>";
			break;
			
			case 4:
				$newVerliProfile = array();
				foreach ($_POST as $field_name => $verli_class)
				{
					if (substr($field_name,0,8)== 'profile_') $newVerliProfile[substr($field_name,8)] = $verli_class;
				}
				
				echo "<tr>
						<td colspan=\"2\">";
				$i = 0;
				$j = 0;
				$error = array();
				print_r($newVerliProfile);
				foreach ($db as $key => $object)
				{
					$i++;
					if (!mysql_query("INSERT INTO `reglist` (`nick`, `class`, `reg_date`, `reg_op`, `login_pwd`) VALUES ('".$object->getNick()."', '".$newVerliProfile[$object->getProfile()]."', '".time()."', 'vhcp', '".crypt($object->getPassword(),0)."')"))
					{
						$error[$j] = $object->getNick();
						$j++;
					}
				}
				echo "$i users have been imported into the database";
				if (count($error) > 0 )
				{	
					echo "; the following users already exist:<br>";
					foreach ($error as $key => $user) echo "- $user<br>";
				}
				echo "</td>
					</tr>";
				unlink($_SESSION['file_name']);
				unset($_SESSION['file_name']);
			break;
			default:
				break;
		}
	}
		
	/**
	 * Read and parse the Ptokax reg account; it creates some PtokaxProfile Objects with nick, password and profile
	 * @access public
	 * @return array
	 */
	
	function readPtoFile($filename,$pppppp)
	{
	    $data = implode("", file($filename));
	    $parser = xml_parser_create();
	    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
	    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
	    xml_parse_into_struct($parser, $data, $values, $tags);
	    xml_parser_free($parser);
		foreach ($tags as $key=>$val)
		{
			if ($key == $pppppp)
			{
				$ranges = $val;
		        for ($i=0; $i < count($ranges); $i+=2)
		        {
		        	$offset = $ranges[$i] + 1;
		            $len = $ranges[$i + 1] - $offset;
		            $tdb[] = ConversionUtility::parseValues(array_slice($values, $offset, $len));
		        }
		    }
		    else
		    {
		    	continue;
		    }
		}
	    return $tdb;
	}
	
	/**
	 * Parse values
	 * @return PtokaxProfile
	 * @access public
	 */
	
	public function parseValues($mvalues)
	{
		for ($i=0; $i < count($mvalues); $i++)
		{
	    	$mol[$mvalues[$i]["tag"]] = @$mvalues[$i]["value"];
		}
	    return new PtokaxProfile($mol);
	}
	
	/**
	 * Detect the Ptokax profiles in the xml file
	 * @param $db
	 * @return PtokaxProfile
	 * @access public
	 */
	
	
	public function detectProfile($db)
    {
    	$i = 0;
		foreach ($db as $key => $object)
		{
			$current_profiles[$i] = $object->getProfile();
			$i++;
		}
		return array_unique($current_profiles);
	}
}
?>